(ns plf08.cpolibio

  (:require [clojure.string :as str]))

(defn alfabetoc
  []
  (hash-map
   \a "♜♜"
   \á "♜♞"
   \b "♜♝"
   \c "♜♛"
   \d "♜♚"
   \e "♜♖"
   \é "♜♘"
   \f "♜♗"
   \g "♜♕"
   \h "♜♔"
   \i "♞♜"
   \í "♞♞"
   \j "♞♝"
   \k "♞♛"
   \l "♞♚"
   \m "♞♖"
   \n "♞♘"
   \ñ "♞♗"
   \o "♞♕"
   \ó "♞♔"
   \p "♝♜"
   \q "♝♞"
   \r "♝♝"
   \s "♝♛"
   \t "♝♚"
   \u "♝♖"
   \ú "♝♘"
   \ü "♝♗"
   \v "♝♕"
   \w "♝♔"
   \x "♛♜"
   \y "♛♞"
   \z "♛♝"
   \0 "♛♛"
   \1 "♛♚"
   \2 "♛♖"
   \3 "♛♘"
   \4 "♛♗"
   \! "♛♕"
   \¡ "♛♕"
   \" "♛♔"
   \# "♚♜"
   \$ "♚♞"
   \% "♚♝"
   \& "♚♛"
   \' "♚♚"
   \( "♚♖"
   \) "♚♘"
   \* "♚♗"
   \+ "♚♕"
   \, "♚♔"
   \- "♖♜"
   \. "♖♞"
   \/ "♖♝"
   \: "♖♛"
   \; "♖♚"
   \< "♖♖"
   \= "♖♘"
   \> "♖♗"
   \? "♖♕"
   \¿ "♖♕"
   \@ "♖♔"
   \[ "♘♜"
   \\ "♘♞"
   \] "♘♝"
   \^ "♘♛"
   \_ "♘♚"
   \` "♘♖"
   \{ "♘♘"
   \| "♘♗"
   \} "♘♕"
   \~ "♘♔"
   \5 "♗♜"
   \6 "♗♞"
   \7 "♗♝"
   \8 "♗♛"
   \9 "♗♚"
   \A "♗♖"
   \B "♗♘"
   \C "♗♗"
   \D "♗♕"
   \E "♗♔"
   \F "♕♜"
   \G "♕♞"
   \H "♕♝"
   \I "♕♛"
   \J "♕♛"
   \K "♕♚"
   \L "♕♖"
   \M "♕♘"
   \N "♕♗"
   \Ñ "♕♗"
   \O "♕♕"
   \P "♕♔"
   \Q "♔♜"
   \R "♔♞"
   \S "♔♝"
   \T "♔♛"
   \U "♔♚"
   \V "♔♖"
   \W "♔♘"
   \X "♔♗"
   \Y "♔♕"
   \Z "♔♔"))

(defn alfabetod
  []
  (hash-map
   "♜♜"	\a
   "♜♞"	\á
   "♜♝"	\b
   "♜♛"	\c
   "♜♚"	\d
   "♜♖"	\e
   "♜♘"	\é
   "♜♗"	\f
   "♜♕"	\g
   "♜♔"	\h
   "♞♜"	\i
   "♞♞"	\í
   "♞♝"	\j
   "♞♛"	\k
   "♞♚"	\l
   "♞♖"	\m
   "♞♘"	\n
   "♞♗"	\ñ
   "♞♕"	\o
   "♞♔"	\ó
   "♝♜"	\p
   "♝♞"	\q
   "♝♝"	\r
   "♝♛"	\s
   "♝♚"	\t
   "♝♖"	\u
   "♝♘"	\ú
   "♝♗"	\ü
   "♝♕"	\v
   "♝♔"	\w
   "♛♜"	\x
   "♛♞"	\y
   "♛♝"	\z
   "♛♛"	\0
   "♛♚"	\1
   "♛♖"	\2
   "♛♘"	\3
   "♛♗"	\4
   "♛♕"	\¡
   "♛♕"	\!
   "♛♔"	\"
   "♚♜"	\#
   "♚♞"	\$
   "♚♝"	\%
   "♚♛"	\&
   "♚♚"	\'
   "♚♖"	\(
   "♚♘"	\)
   "♚♗"	\*
   "♚♕"	\+
   "♚♔" \,
   "♖♜"	\-
   "♖♞"	\.
   "♖♝"	\/
   "♖♛"	\:
   "♖♚"	\;
   "♖♖"	\<
   "♖♘"	\=
   "♖♗"	\>
   "♖♕"	\?
   "♖♕"	\¿
   "♖♔"	\@
   "♘♜"	\[
   "♘♞"	\\
   "♘♝"	\]
   "♘♛"	\^
   "♘♚"	\_
   "♘♖"	\`
   "♘♘"	\{
   "♘♗"	\|
   "♘♕"	\}
   "♘♔"	\~
   "♗♜"	\5
   "♗♞"	\6
   "♗♝"	\7
   "♗♛"	\8
   "♗♚"	\9
   "♗♖" \A
   "♗♘" \B
   "♗♗" \C
   "♗♕" \D
   "♗♔" \E
   "♕♜" \F
   "♕♞" \G
   "♕♝" \H
   "♕♛" \I
   "♕♛" \J
   "♕♚" \K
   "♕♖" \L
   "♕♘" \M
   "♕♗" \N
   "♕♗" \Ñ
   "♕♕" \O
   "♕♔" \P
   "♔♜" \Q
   "♔♞" \R
   "♔♝" \S
   "♔♛" \T
   "♔♚" \U
   "♔♖" \V
   "♔♘" \W
   "♔♗" \X
   "♔♕" \Y
   "♔♔" \Z))

(defn pcodificar
  [s]
  (let [f (into [] s)]
    (str/join (replace (alfabetoc) f))))

(defn pdecodificar
  [s]
  (let [z (str/join (replace (hash-map \space "  ") s))
        f (vec (take-nth 2 (map str z (drop 1 z))))
        x (replace (alfabetod) f)
        r (str/join (replace (hash-map "  " " ") x))]
    r))

(defn -main
  [op arg1 arg2]
  (if (or (empty? op) (empty? arg1) (empty? arg2))
    (println "Error. Falta algún argumento")
    (if (= op "codificar")
      (spit arg2 (pcodificar (slurp arg1)))
      (if (= op"decodificar")
        (spit arg2 (pdecodificar (slurp arg1)))
        (println "Error fatal. App muerta x.x")))))